# Gradio学习记录

>Gradio 是一个开源 Python 包，可让您为机器学习模型、API 或任何任意 Python 函数快速构建演示或 Web 应用程序。然后，您可以使用 Gradio 的内置共享功能在几秒钟内共享指向您的演示或 Web 应用程序的链接。无需 JavaScript、CSS 或 Web 托管经验！

## Demo

```python{8,9,10}
import gradio as gr

def greet(name, intensity):
    return "Hello, " + name + "!" * int(intensity)

demo = gr.Interface(
    #传入创建UI的函数,输入组件,输出组件。
    fn=greet,
    inputs=["text", "slider"],
    outputs=["text"],
)

demo.launch()
```

## InterFace 类





# 标题

## 小标题

**深色**

`强调`

[GitHub](https://github.com/)

- 列表1
  
> 区块引用
>> 嵌套引用

分割线

---

::: tip 重要
记录容器
:::

::: warning 提醒
记录容器
:::

| 表头 | 表头 |
| ---- | ---- |
| 单元格 | 单元格 |
| 单元格 | 单元格 |

## 代码块

```shell
sudo apt-get update
```

## 代码块中聚焦

```js
export default {
  data () {
    return {
      msg: 'Focused!' // [!code focus]
    }
  }
}
```

## 代码分组

::: code-group

```js [代码1.js]
/**
 * @type {import('vitepress').UserConfig}
 */
const config = {
  // ...
}

export default config
```

```ts [代码2.ts]
import type { UserConfig } from 'vitepress'

const config: UserConfig = {
  // ...
}

export default config
```

:::